<template>
    <input ref="input" @input="handleOnInputValue" @change="telephoneMask"   :value="props.modelValue" :placeholder="props.placeholder" class="w-full h-[50px] outline-none pl-[10px] bg-[#F8FAFC] rounded-[4px]" type="text">
</template>

<script setup>
import { onMounted, ref } from 'vue'
import IMask from 'imask'
const props = defineProps({
  placeholder: {
    type: String,
    default: 'Required field'
  },
  modelValue: {
    type: String,
    required: true
  },
  mask: {
    type: Boolean,
    default: false
  }
})
const emit = defineEmits({ 'update:model-value': null, masked: null })
const handleOnInputValue = (event) => {
  const value = event.target.value
  emit('update:model-value', value.trim())
}

const input = ref(null)

const telephoneMask = () => {
  if (props.mask) {
    const maskOptions = {
      mask: '+38(000)000-0000',
      lazy: false
    }
    const masked = IMask(input.value, maskOptions)
    emit('masked', masked)
  }
}

onMounted(() => {
  if (props.mask) {
    telephoneMask()
  }
})
</script>
